diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
index 084b46697..1fa6d23c5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
@@ -10,92 +10,78 @@ import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
 
 import java.util.Arrays;
 import java.util.List;
+import java.util.Objects;
 
 public class TerrainRendererMultiDraw extends TerrainRenderer {
 
-    public final int VERTEX_BUFFER_INITIAL_CAPACITY = 67108864;
+    public static final int VERTEX_BUFFER_INITIAL_CAPACITY = 67108864;
 
-    public final int RENDER_LIST_INITIAL_CAPACITY = 4096;
+    public static final int RENDER_LIST_INITIAL_CAPACITY = 4096;
 
     /**
      * Exponential Region Size
      * Lower Region Size: More Draw Calls, reduced FPS
      * Higher Region Size: More Visual Artifacts
      */
-    public final int REGION_SIZE = 9;
+    public static final int REGION_SIZE = 9;
 
-    public final int MAX_RENDER_PASSES = 2;
+    public static final int MAX_RENDER_PASSES = 2;
 
-    public VertexBuffer vertexBuffer;
-    public RegionBuffer regionBuffer;
+    public final @NotNull VertexBuffer vertexBuffer;
+    public final @NotNull RegionBuffer<TessellatorTerrainImpl.TerrainVertexConfig> regionBuffer;
 
-    private VertexConfig<?> terrainVertexConfig;
+    private final @NotNull TessellatorTerrainImpl.TerrainVertexConfig vertexConfig;
 
-    int[] drawCalls = new int[this.MAX_RENDER_PASSES];
+    private final int @NotNull [] drawCalls = new int[MAX_RENDER_PASSES];
 
-    private double renderPosX;
-    private double renderPosY;
-    private double renderPosZ;
+    private final @NotNull Vector3d renderPos = new Vector3d();
+    private final @NotNull Vector3d prevSort = new Vector3d();
+    private final @NotNull Vector3d d = new Vector3d();
 
-    private double prevSortX;
-    private double prevSortY;
-    private double prevSortZ;
-
-    public TerrainRendererMultiDraw(Minecraft minecraft) {
+    public TerrainRendererMultiDraw(final @NotNull Minecraft minecraft) {
         super(minecraft);
 
-        this.vertexBuffer = new VertexBuffer(this.VERTEX_BUFFER_INITIAL_CAPACITY);
-        this.regionBuffer = new RegionBuffer(this.REGION_SIZE);
+        this.vertexConfig = new TessellatorTerrainImpl.TerrainVertexConfig();
+
+        this.vertexBuffer = new VertexBuffer(VERTEX_BUFFER_INITIAL_CAPACITY);
+        this.regionBuffer = new RegionBuffer<>(REGION_SIZE);
     }
 
     @Override
-    public void renderSolidTerrain(float partialTicks) {
+    public void renderSolidTerrain(final float partialTicks) {
         Arrays.fill(this.drawCalls, 0);
 
-        ICamera camera = this.mc.activeCamera;
-        this.renderPosX = camera.getX(partialTicks);
-        this.renderPosY = camera.getY(partialTicks);
-        this.renderPosZ = camera.getZ(partialTicks);
-
-        double dX = this.renderPosX - this.prevSortX;
-        double dY = this.renderPosY - this.prevSortY;
-        double dZ = this.renderPosZ - this.prevSortZ;
+        final @NotNull ICamera camera = Objects.requireNonNull(this.mc.activeCamera);
+        camera.getPosition(partialTicks, this.renderPos);
 
-        if (dX * dX + dY * dY + dZ * dZ > 64) {
-            this.prevSortX = this.renderPosX;
-            this.prevSortY = this.renderPosY;
-            this.prevSortZ = this.renderPosZ;
+        this.d.set(this.renderPos).sub(this.prevSort);
 
-            int x = MathHelper.floor(this.renderPosX);
-            int y = MathHelper.floor(this.renderPosY);
-            int z = MathHelper.floor(this.renderPosZ);
+        if (this.d.dot(this.d) > 64) {
+            this.prevSort.set(this.renderPos);
 
-            this.mc.renderGlobal.resortChunks(x, y, z);
+            this.mc.renderGlobal.resortChunks(
+                MathHelper.floor(this.renderPos.x),
+                MathHelper.floor(this.renderPos.y),
+                MathHelper.floor(this.renderPos.z)
+            );
         }
 
-        if (this.terrainVertexConfig == null) {
-            return;
-        }
-
-        this.terrainVertexConfig.enable(this.vertexBuffer.getVao(), this.vertexBuffer.getVbo());
+        this.vertexConfig.enable(this.vertexBuffer.getVao(), this.vertexBuffer.getVbo());
 
-        List<RenderRegion> regions = this.regionBuffer.getAllRegions();
-        for (int i = 0; i < regions.size(); i++) {
-            RenderRegion region = regions.get(i);
-            // TODO Clear empty regions, but not like this
-//			if(!region.hasRenderData()) {
-//				regionBuffer.remove(region);
-//				i--;
-//				continue;
-//			}
+        final @NotNull List<@NotNull RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig>> regions = this.regionBuffer.getAllRegions();
+        for (final @NotNull RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig> region : regions) {
+            // TODO: Clear empty regions
 
-            RenderList renderList = region.renderLists[0];
+            final @Nullable RenderList<?> renderList = region.renderLists[0];
             if (renderList != null && renderList.size() > 0) {
                 GLRenderer.pushFrame();
-                GLRenderer.modelM4f().translate((float) ((region.posX << this.REGION_SIZE) - this.renderPosX), (float) -this.renderPosY, (float) ((region.posZ << this.REGION_SIZE) - this.renderPosZ));
+                GLRenderer.modelM4f().translate((float) ((region.posX << REGION_SIZE) - this.renderPos.x), (float) -this.renderPos.y, (float) ((region.posZ << REGION_SIZE) - this.renderPos.z));
                 GLRenderer.globalSetUniforms(Shaders.TERRAIN);
 
                 renderList.draw();
@@ -105,17 +91,16 @@ public class TerrainRendererMultiDraw extends TerrainRenderer {
             }
         }
 
-        this.terrainVertexConfig.disable();
+        this.vertexConfig.disable();
     }
 
-    public void renderAllLists(int renderPass) {
-        List<RenderRegion> regions = this.regionBuffer.getAllRegions();
-        for (int i = 0; i < regions.size(); i++) {
-            RenderRegion region = regions.get(i);
-            RenderList renderList = region.renderLists[renderPass];
+    public void renderAllLists(final int renderPass) {
+        final @NotNull List<@NotNull RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig>> regions = this.regionBuffer.getAllRegions();
+        for (final @NotNull RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig> region : regions) {
+            final @Nullable RenderList<TessellatorTerrainImpl.TerrainVertexConfig> renderList = region.renderLists[renderPass];
             if (renderList != null && renderList.size() > 0) {
                 GLRenderer.pushFrame();
-                GLRenderer.modelM4f().translate((float) ((region.posX << this.REGION_SIZE) - this.renderPosX), (float) -this.renderPosY, (float) ((region.posZ << this.REGION_SIZE) - this.renderPosZ));
+                GLRenderer.modelM4f().translate((float) ((region.posX << REGION_SIZE) - this.renderPos.x), (float) -this.renderPos.y, (float) ((region.posZ << REGION_SIZE) - this.renderPos.z));
                 GLRenderer.globalSetUniforms(Shaders.TERRAIN);
 
                 renderList.draw();
@@ -127,117 +112,102 @@ public class TerrainRendererMultiDraw extends TerrainRenderer {
     }
 
     @Override
-    public void renderTranslucentTerrain(float partialTicks) {
-        if (this.terrainVertexConfig == null) {
-            return;
-        }
-
-        this.terrainVertexConfig.enable(this.vertexBuffer.getVao(), this.vertexBuffer.getVbo());
+    public void renderTranslucentTerrain(final float partialTicks) {
+        this.vertexConfig.enable(this.vertexBuffer.getVao(), this.vertexBuffer.getVbo());
 
         if (GameSettings.TRANSPARENCY_DEPTH_CHECK.value) {
             GLRenderer.setColorMask(false, false, false, false);
         }
 
-        renderAllLists(1);
+        this.renderAllLists(1);
 
         if (GameSettings.TRANSPARENCY_DEPTH_CHECK.value) {
             GLRenderer.setColorMask(true, true, true, true);
             if (this.drawCalls[1] > 0) {
-                renderAllLists(1);
+                this.renderAllLists(1);
             }
         }
 
-        this.terrainVertexConfig.disable();
+        this.vertexConfig.disable();
     }
 
-    public void chunkRendered(ChunkRendererMultiDraw chunkRenderer, TessellatorTerrainImpl tessellator, final int renderPass) {
+    public void chunkRendered(final @NotNull ChunkRendererMultiDraw chunkRenderer, final @NotNull TessellatorTerrainImpl tessellator, final int renderPass) {
         tessellator.drawing = false;
-        VertexConfig<?> config = tessellator.data.config;
-
-        if (this.terrainVertexConfig == null) {
-            this.terrainVertexConfig = config.copy();
-        } else {
-            if (!this.terrainVertexConfig.equals(tessellator.data.config)) {
-                List<RenderRegion> allRegions = this.regionBuffer.getAllRegions();
-                for (int i = 0; i < allRegions.size(); i++) {
-                    RenderRegion region = allRegions.get(i);
-                    if (region.hasRenderData()) {
-                        VertexConfigStandard.compareThrow(tessellator.data.config, this.terrainVertexConfig);
-                    }
-                    this.regionBuffer.remove(region);
-                    i--;
-                }
-
-                this.terrainVertexConfig = config.copy();
-            }
-        }
 
-        RenderList renderList = getOrCreateRenderList(chunkRenderer, renderPass);
-        Entry entry = renderList.add(tessellator.data, chunkRenderer.visible);
+        final @NotNull RenderList<TessellatorTerrainImpl.TerrainVertexConfig> renderList = this.getOrCreateRenderList(chunkRenderer, renderPass);
+        final @Nullable Entry<TessellatorTerrainImpl.TerrainVertexConfig> entry = renderList.add(tessellator.data, chunkRenderer.visible);
         chunkRenderer.renderListEntries[renderPass] = entry;
     }
 
-    public void chunkVisibilityChanged(ChunkRendererMultiDraw chunkRenderer) {
-        RenderRegion region = getRenderRegionAtBlockPos(chunkRenderer.posX, chunkRenderer.posZ);
+    public void chunkVisibilityChanged(final @NotNull ChunkRendererMultiDraw chunkRenderer) {
+        final @NotNull RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig> region = this.getRenderRegionAtBlockPos(chunkRenderer.pos.x, chunkRenderer.pos.z);
 
-        for (int renderPass = 0; renderPass < this.MAX_RENDER_PASSES; renderPass++) {
-            Entry entry = chunkRenderer.renderListEntries[renderPass];
-            if (entry == null) {
-                continue;
-            }
-            RenderList renderList = region.renderLists[renderPass];
-            if (renderList == null) {
-                throw new NullPointerException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
+        for (int renderPass = 0; renderPass < MAX_RENDER_PASSES; renderPass++) {
+            final @Nullable Entry<TessellatorTerrainImpl.TerrainVertexConfig> entry = chunkRenderer.renderListEntries[renderPass];
+
+            if (entry != null) {
+                final @Nullable RenderList<TessellatorTerrainImpl.TerrainVertexConfig> renderList = region.renderLists[renderPass];
+                if (renderList == null) {
+                    throw new IllegalStateException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
+                }
+
+                renderList.setVisible(entry, chunkRenderer.visible);
             }
-            renderList.setVisible(entry, chunkRenderer.visible);
         }
     }
 
-    public void chunkDeleted(ChunkRendererMultiDraw chunkRenderer) {
-        RenderRegion region = getRenderRegionAtBlockPos(chunkRenderer.posX, chunkRenderer.posZ);
-        for (int renderPass = 0; renderPass < this.MAX_RENDER_PASSES; renderPass++) {
-            Entry entry = chunkRenderer.renderListEntries[renderPass];
-            if (entry == null) {
-                continue;
-            }
-            RenderList renderList = region.renderLists[renderPass];
-            if (renderList == null) {
-                throw new NullPointerException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
+    public void chunkDeleted(final @NotNull ChunkRendererMultiDraw chunkRenderer) {
+        final @NotNull RenderRegion<TessellatorTerrainImpl.@NotNull TerrainVertexConfig> region = this.getRenderRegionAtBlockPos(chunkRenderer.pos.x, chunkRenderer.pos.z);
+
+        for (int renderPass = 0; renderPass < MAX_RENDER_PASSES; renderPass++) {
+            final @Nullable Entry<TessellatorTerrainImpl.@NotNull TerrainVertexConfig> entry = chunkRenderer.renderListEntries[renderPass];
+            if (entry != null) {
+                final @Nullable RenderList<TessellatorTerrainImpl.@NotNull TerrainVertexConfig> renderList = region.renderLists[renderPass];
+                if (renderList == null) {
+                    throw new IllegalStateException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
+                }
+
+                renderList.remove(entry);
+                chunkRenderer.renderListEntries[renderPass] = null;
             }
-            renderList.remove(entry);
-            chunkRenderer.renderListEntries[renderPass] = null;
         }
     }
 
-    public RenderList getOrCreateRenderList(ChunkRendererMultiDraw chunkRenderer, final int renderPass) {
-        return getOrCreateRenderList(chunkRenderer.posX, chunkRenderer.posZ, renderPass);
+    public @NotNull RenderList<TessellatorTerrainImpl.@NotNull TerrainVertexConfig> getOrCreateRenderList(final @NotNull ChunkRendererMultiDraw chunkRenderer, final int renderPass) {
+        return this.getOrCreateRenderList(chunkRenderer.pos.x, chunkRenderer.pos.z, renderPass);
     }
 
-    public RenderList getOrCreateRenderList(int posX, int posZ, final int renderPass) {
-        RenderRegion region = this.regionBuffer.getRegionAtBlockPos(posX, posZ);
-        RenderList renderList = region.renderLists[renderPass];
+    public @NotNull RenderList<TessellatorTerrainImpl.@NotNull TerrainVertexConfig> getOrCreateRenderList(final int posX, final int posZ, final int renderPass) {
+        final @NotNull RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig> region = this.regionBuffer.getRegionAtBlockPos(posX, posZ);
+
+        @Nullable RenderList<TessellatorTerrainImpl.TerrainVertexConfig> renderList = region.renderLists[renderPass];
         if (renderList == null) {
-            renderList = new RenderList(this.vertexBuffer, this.RENDER_LIST_INITIAL_CAPACITY);
+            renderList = new RenderList<>(this.vertexBuffer, this.vertexConfig, RENDER_LIST_INITIAL_CAPACITY);
             region.renderLists[renderPass] = renderList;
         }
+
         return renderList;
     }
 
     @Override
-    public ChunkRenderer createChunkRenderer(World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size) {
+    public @NotNull ChunkRenderer createChunkRenderer(
+        final @NotNull World world,
+        final @NotNull List<@NotNull TileEntity> globalRenderableTileEntities,
+        final int x, final int y, final int z,
+        final int size
+    ) {
         return new ChunkRendererMultiDraw(this, world, globalRenderableTileEntities, x, y, z, size);
     }
 
-    public RenderRegion getRenderRegionAtBlockPos(int blockX, int blockZ) {
+    public @NotNull RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig> getRenderRegionAtBlockPos(final int blockX, final int blockZ) {
         return this.regionBuffer.getRegionAtBlockPos(blockX, blockZ);
     }
 
     public int getTotalDrawCalls() {
         int totalDrawCalls = 0;
-        for (int i = 0; i < this.drawCalls.length; i++) {
-            totalDrawCalls += this.drawCalls[i];
+        for (final int drawCall : this.drawCalls) {
+            totalDrawCalls += drawCall;
         }
         return totalDrawCalls;
     }
-
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
index 144115d11..de715ee04 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
@@ -4,134 +4,145 @@ import static org.lwjgl.opengl.GL41.*;
 
 import java.util.ArrayList;
 import java.util.List;
+import java.util.Objects;
 
 import com.mojang.logging.CategorizedLogger;
 import com.mojang.logging.LogUtils;
 
 import net.minecraft.client.render.OpenGLHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL41;
 
 /**
- * 		A large buffer that contains vertex data
- * <br> Elements can have different vertex configurations
- * <br> When the buffer is full, it will automatically expand
+ * A large buffer that contains vertex data
+ * <br>
+ * Elements can have different vertex configurations
+ * <br>
+ * When the buffer is full, it will automatically expand
  */
 public class VertexBuffer {
-	public static final CategorizedLogger LOGGER = LogUtils.getLogger();
-	private int vbo;
-	private final int vao;
-	private long capacity;
-	
-	public List<Entry> entries = new ArrayList<>();
-	
-	private int entryHashCounter;
-	
-	public VertexBuffer(long initialCapacity) {
-		this.capacity = initialCapacity;
+    private static final @NotNull CategorizedLogger LOGGER = LogUtils.getLogger();
+
+    public final @NotNull List<@NotNull Entry<?>> entries = new ArrayList<>();
+
+    private int vbo;
+    private final int vao;
+    private long capacity;
+    private int entryHashCounter;
+
+    public VertexBuffer(final long initialCapacity) {
+        this.capacity = initialCapacity;
 
         this.vbo = glGenBuffers();
         this.vao = GL41.glGenVertexArrays();
-		glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
-		glBufferData(GL_ARRAY_BUFFER, this.capacity, GL_STATIC_DRAW);
-		glBindBuffer(GL_ARRAY_BUFFER, 0);
-	}
-	
-	public Entry addVertexData(VertexData vertexData) {
-		if(vertexData.vertexCount <= 0) {
-			return null;
-		}
-		
-		// If the buffer is empty, just put it at the start
-		if(this.entries.isEmpty()) {
-			return insertAtIndex(vertexData, 0);
-		}
-		
-		int bytes = vertexData.buffer.position();
-		
-		// If there is a single element in the buffer, check if there is enough space in front of it
-		// If not put it behind the other element
-		if(this.entries.size() == 1) {
-			Entry entry = this.entries.get(0);
-			if(entry.position > bytes) {
-				return insertAtIndex(vertexData, 0);
-			}else {
-				return insertAtIndex(vertexData, 1);
-			}
-		}
-		
-		// Check between every single element for a large enough gap
-		for(int i = 0; i < this.entries.size() - 1; i++) {
-			Entry entry = this.entries.get(i);
-			Entry nextEntry = this.entries.get(i + 1);
-			
-			long availableSpace = nextEntry.position - (entry.position + entry.size);
-			if(availableSpace > bytes) {
-				return insertAtIndex(vertexData, i + 1);
-			}
-		}
-		
-		// Put it all the way at the end
-		return insertAtIndex(vertexData, this.entries.size());
-	}
-	
-	private Entry insertAtIndex(VertexData vertexData, int listIndex) {
-		long pos = 0;
-		long bytes = vertexData.buffer.position();
-		
-		if(listIndex > 0) {
-			Entry prev = this.entries.get(listIndex - 1);
-			pos = prev.position + prev.size;
-		}
-		
-		if(pos + bytes >= this.capacity) {
-			expandVBO();
-		}
-		
-		Entry entry = new Entry(pos, bytes);
-		
-		if(listIndex > 0) {
-			Entry previousEntry = this.entries.get(listIndex - 1);
-			if(previousEntry.position + previousEntry.size > pos) {
-				throw new RuntimeException("Entry collision: " + entry + " and " + previousEntry);
-			}
-		}
-		if(listIndex < this.entries.size() - 1) {
-			Entry nextEntry = this.entries.get(listIndex + 1);
-			if(nextEntry.position <= pos + bytes) {
-				throw new RuntimeException("Entry collision: " + entry + " and " + nextEntry);
-			}
-		}
-		
-		vertexData.buffer.flip();
-
-		assert pos >= 0: "Entry pos must be positive!";
-		
-		glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
-		glBufferSubData(GL_ARRAY_BUFFER, pos, vertexData.buffer);
-		glBindBuffer(GL_ARRAY_BUFFER, 0);
+        glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
+        glBufferData(GL_ARRAY_BUFFER, this.capacity, GL_STATIC_DRAW);
+        glBindBuffer(GL_ARRAY_BUFFER, 0);
+    }
+
+    public <V extends VertexConfig<V>> @Nullable Entry<V> addVertexData(final @NotNull VertexData<V> vertexData) {
+        if (vertexData.vertexCount <= 0) {
+            return null;
+        }
+
+        // If the buffer is empty, just put it at the start
+        if (this.entries.isEmpty()) {
+            return this.insertAtIndex(vertexData, 0);
+        }
+
+        final int bytes = vertexData.getBuffer().position();
+
+        // If there is a single element in the buffer, check if there is enough space in front of it
+        // If not put it behind the other element
+        if (this.entries.size() == 1) {
+            final @Nullable Entry<?> entry = this.entries.get(0);
+            assert entry != null;
+            if (entry.position > bytes) {
+                return this.insertAtIndex(vertexData, 0);
+            } else {
+                return this.insertAtIndex(vertexData, 1);
+            }
+        }
+
+        // Check between every single element for a large enough gap
+        for (int i = 0; i < this.entries.size() - 1; i++) {
+            final @Nullable Entry<?> entry = this.entries.get(i);
+            final @Nullable Entry<?> nextEntry = this.entries.get(i + 1);
+            assert entry != null;
+            assert nextEntry != null;
+
+            final long availableSpace = nextEntry.position - (entry.position + entry.size);
+            if (availableSpace > bytes) {
+                return this.insertAtIndex(vertexData, i + 1);
+            }
+        }
+
+        // Put it all the way at the end
+        return this.insertAtIndex(vertexData, this.entries.size());
+    }
+
+    private <V extends VertexConfig<V>> @NotNull Entry<V> insertAtIndex(final @NotNull VertexData<V> vertexData, final int listIndex) {
+        long pos = 0;
+        final long bytes = vertexData.getBuffer().position();
+
+        if (listIndex > 0) {
+            final @Nullable Entry<?> prev = this.entries.get(listIndex - 1);
+            assert prev != null;
+            pos = prev.position + prev.size;
+        }
+
+        if (pos + bytes >= this.capacity) {
+            this.expandVBO();
+        }
+
+        final @NotNull Entry<V> entry = new Entry<>(vertexData.config, pos, bytes);
+
+        if (listIndex > 0) {
+            final @Nullable Entry<?> previousEntry = this.entries.get(listIndex - 1);
+            assert previousEntry != null;
+            if (previousEntry.position + previousEntry.size > pos) {
+                throw new RuntimeException("Entry collision: " + entry + " and " + previousEntry);
+            }
+        }
+        if (listIndex < this.entries.size() - 1) {
+            final @Nullable Entry<?> nextEntry = this.entries.get(listIndex + 1);
+            assert nextEntry != null;
+            if (nextEntry.position <= pos + bytes) {
+                throw new RuntimeException("Entry collision: " + entry + " and " + nextEntry);
+            }
+        }
+
+        vertexData.getBuffer().flip();
+
+        assert pos >= 0 : "Entry pos must be positive!";
+
+        glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
+        glBufferSubData(GL_ARRAY_BUFFER, pos, vertexData.getBuffer());
+        glBindBuffer(GL_ARRAY_BUFFER, 0);
 
         this.entries.add(listIndex, entry);
-		
-		return entry;
-	}
-	
-	private void expandVBO() {
-		final long prevCapacity = this.capacity;
-		long newCapacity = this.capacity * 2L;
-		if(newCapacity < this.capacity) {
-			// future proof
-			throw new RuntimeException();
-		}
-
-		LOGGER.warn("Expand VBO Buffer: " + newCapacity);
-		
-		OpenGLHelper.checkError("pre expand buffer");
-		
-		int newBuffer = glGenBuffers();
-		glBindBuffer(GL_ARRAY_BUFFER, newBuffer);
-		glBufferData(GL_ARRAY_BUFFER, newCapacity, GL_STATIC_DRAW);
-		
-		OpenGLHelper.checkError("create expand buffer");
+
+        return entry;
+    }
+
+    private void expandVBO() {
+        final long prevCapacity = this.capacity;
+        final long newCapacity = this.capacity * 2L;
+        if (newCapacity < this.capacity) {
+            // future proof
+            throw new RuntimeException();
+        }
+
+        LOGGER.warn("Expand VBO Buffer: " + newCapacity);
+
+        OpenGLHelper.checkError("pre expand buffer");
+
+        final int newBuffer = glGenBuffers();
+        glBindBuffer(GL_ARRAY_BUFFER, newBuffer);
+        glBufferData(GL_ARRAY_BUFFER, newCapacity, GL_STATIC_DRAW);
+
+        OpenGLHelper.checkError("create expand buffer");
 
         glBindBuffer(GL41.GL_COPY_READ_BUFFER, this.vbo);
         glBindBuffer(GL41.GL_COPY_WRITE_BUFFER, newBuffer);
@@ -142,52 +153,54 @@ public class VertexBuffer {
         glBindBuffer(GL41.GL_COPY_WRITE_BUFFER, 0);
 
         OpenGLHelper.checkError("copy buffer");
-		
-		this.capacity = newCapacity;
-		this.vbo = newBuffer;
-	}
-	
-	public boolean removeEntry(Entry entry) {
-		return this.entries.remove(entry);
-	}
-	
-	public int getVbo() {
-		return this.vbo;
-	}
-
-	public int getVao() {
-		return this.vao;
-	}
-	
-	public int entryCount() {
-		return this.entries.size();
-	}
-	
-	/**
-	 * A reference to some vertex data that has been stored in this buffer
-	 */
-	public class Entry {
-		
-		public final long position;
-		public final long size;
-		
-		private final int hashCode = VertexBuffer.this.entryHashCounter++;
-		
-		public Entry(long position, long size) {
-			this.position = position;
-			this.size = size;
-		}
-		
-		@Override
-		public String toString() {
-			return "VertexBufferEntry[position: " + this.position + ", size: " + this.size + "]";
-		}
-		
-		@Override
-		public int hashCode() {
-			return this.hashCode;
-		}
-		
-	}
+
+        this.capacity = newCapacity;
+        this.vbo = newBuffer;
+    }
+
+    public void removeEntry(final Entry<?> entry) {
+        this.entries.remove(entry);
+    }
+
+    public int getVbo() {
+        return this.vbo;
+    }
+
+    public int getVao() {
+        return this.vao;
+    }
+
+    public int entryCount() {
+        return this.entries.size();
+    }
+
+    /**
+     * A reference to some vertex data that has been stored in this buffer
+     */
+    public class Entry<V extends VertexConfig<V>> {
+
+        public final long position;
+        public final long size;
+        public final @NotNull V config;
+
+        private final int hashCode = VertexBuffer.this.entryHashCounter++;
+
+        public Entry(final @NotNull V config, final long position, final long size) {
+            this.config = config;
+            this.position = position;
+            this.size = size;
+        }
+
+        @Override
+        public String toString() {
+            return "VertexBufferEntry[position: " + this.position + ", size: " + this.size + "]";
+        }
+
+        @Override
+        public int hashCode() {
+            return this.hashCode;
+        }
+
+    }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java
index da09d570e..d00009c7c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java
@@ -4,9 +4,13 @@ import net.minecraft.client.render.renderer.DrawMode;
 import org.jetbrains.annotations.NotNull;
 
 public interface VertexConfig<T extends VertexConfig<T>> {
-    @NotNull DrawMode drawmode();
+    @NotNull DrawMode drawMode();
+
     void enable(int vao, int vbo);
+
     void disable();
+
     int getVertexSize();
+
     @NotNull T copy();
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java
index aa1c5408c..00f0aa277 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java
@@ -2,18 +2,40 @@ package net.minecraft.client.render.terrain;
 
 import java.nio.ByteBuffer;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.util.helper.Buffer;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.BufferUtils;
+import org.slf4j.Logger;
 
-public class VertexData {
+public class VertexData<V extends VertexConfig<V>> {
+    private static final Logger LOGGER = LogUtils.getLogger();
 
-    public ByteBuffer buffer;
-
-    public VertexConfig<?> config = new VertexConfigStandard();
+    public final @NotNull V config;
 
     public int vertexCount;
 
-    public VertexData(int size) {
+    private @NotNull ByteBuffer buffer;
+
+    public VertexData(final @NotNull V config, final int size) {
+        this.config = config;
         this.buffer = BufferUtils.createByteBuffer(size);
     }
+
+    public @NotNull ByteBuffer getBuffer() {
+        return this.buffer;
+    }
+
+    public void resizeIfNeeded(final int size) {
+        if (this.buffer.capacity() < this.buffer.position() + size) {
+            final int newSize = this.buffer.capacity() * 2;
+
+            LOGGER.info("Expanding {} Buffer ({} -> {})", this.getClass().getSimpleName(), this.buffer.capacity(), newSize);
+
+            final @NotNull ByteBuffer newBuffer = BufferUtils.createByteBuffer(newSize);
+            this.buffer.flip();
+            newBuffer.put(this.buffer);
+            this.buffer = newBuffer;
+        }
+    }
 }
